//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "DirectIOmain.h"
#include "KPCIDIOLib_TLB.h"
using namespace Kpcidiolib_tlb; // this namespace created by
                                // importing type library
// tested with KPCIPIO-850A04 in Win2kSP1 with KPCI-PIO24
// Borland Builder C++ 5.0 Standard
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;
// declare an instance of the KPCIPIO object.
Kpcidiolib_tlb::IKPCIPIOPtr pdio;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TForm1::cmdOpenClick(TObject *Sender)
{
  try
  {
        CoInitialize(NULL);
        pdio.CreateInstance(Kpcidiolib_tlb::CLSID_KPCIPIO);
	pdio->OpenDevice(0); //Open KPCIPIO device
        Label1->Caption = " Object Created";
  }
  catch(Exception &exception )
  {
     Label1->Caption = " Error in Object Creation";
  }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::cmdConfigureClick(TObject *Sender)
{
    pdio->Write(3,0x80); //Make all ports outputs        
}
//---------------------------------------------------------------------------

void __fastcall TForm1::cmdLogicHighClick(TObject *Sender)
{
  pdio->Write(0,0x1); //take LSB at port A to logic 1
  Label1->Caption =" Value at Port A: " + IntToStr(pdio->Read(0)); //read back port A
}
//---------------------------------------------------------------------------


void __fastcall TForm1::cmdLogicLowClick(TObject *Sender)
{
  pdio->Write(0,0x0); //take LSB at port A to logic 0
  Label1->Caption =" Value at Port A: " + IntToStr(pdio->Read(0));
   //read back port A
}
//---------------------------------------------------------------------------

void __fastcall TForm1::CleanUp(TObject *Sender, TCloseAction &Action)
{
   // close our object and release COM subsystem
    pdio->CloseDevice();
    CoUninitialize();
}
//---------------------------------------------------------------------------

